Subject: Re: Git mirror at gitlab

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 28 Dec 2023 12:13:38 +0100

On Fri, Dec 22, 2023 at 03:06:08PM +0100, Olliver Schinagl wrote:
> Hey Patrick,
> 
> On December 21, 2023 12:48:12 p.m. GMT+01:00, Patrick Steinhardt <[email-masked]> wrote:
> >On Thu, Dec 21, 2023 at 12:30:02PM +0100, Olliver Schinagl wrote:
> >> Hey list,
> >> 
> >> For years, I wanted (tried, but time) to run the mirror for git on gitlab.
> >> Actually, the original idea was to run a docker container ([0] 10k+ pulls
> >> :p)
> >> 
> >> I initially set this up via docker build containers, where docker hub would
> >> pull my mirror of the git repo. My mirror, because I added a Dockerfile
> >> which was enough for docker to do its trick. I was planning (time ..) on
> >> submitting this upstream to the list, but never did. Because of me not doing
> >> that, I had to manually (I was even too lazy to script it) rebase the
> >> branch. Docker then did some changes to their business, where the docker
> >> builds where not possible anymore.
> >> 
> >> So then I figured, I'll do the same on gitlab and push it to the docker hub.
> >> Thus I setup a mirror on gitlab [1], with the idea to work there on it.
> >> 
> >> Again, I never got around to finalize this work, mostly because the docker
> >> container 'just worked' for pretty much everything. After all, git is very
> >> stable overal.
> >> 
> >> So very interestingly, last month commit 0e3b67e2aa25edb ("ci: add support
> >> for GitLab CI") landed, which started to trigger pipeline jobs!
> >> 
> >> Sadly, this only worked for 3 builds, as that's when the minutes ran out :)
> >> 
> >> So one, I would very much like to offer the registered names (cause they are
> >> pretty nice in name) to here, so people can use and find it.
> >
> >Not to throw a wrench into this, but are you aware of the official
> >GitLab mirror at https://gitlab.com/git-vcs/git? I myself wasn't aware
> >of this mirror for a rather long time.
> 
> Not a wrench at all, and no, I didn't know. How old is it though :p
> could be that git-vcs was created cause I owned gitscm :)
> 
> I had chosen gitscm to match the official site, git-scm.org. the
> hyphen I left out because afaik it wasn't allowed on docker hub.

No idea when exactly this mirror was created. The first mention of it in
the "What's cooking" report is in December 2020, 489058b80d (What's
cooking (2023/12 #05), 2023-12-27).

> >I also wondered whether we want to have https://gitlab.com/git/git as we
> >do on GitHub. I don't think anybody registered it, but it is blocked
> >from being registered as far as I can tell. Maybe we block the namespace
> >out of caution, I dunno. I can certainly check in with our SREs in case
> >it is something the Git project would like to own.
> 
> Yeah couldn't figure out who it was either ... hence gitscm.
> 
> Sadly gitlab doesn't support aliases :) I'm more then happy to hand
> over the space. Whatever name is decided to be best.

I don't particularly mind the name we ultimately settle with. The most
pragmatic choice would likely be to stick with what we already have.
Ideally, all the others would then be created as forks of the official
one so that they point back to it. Like this, users can learn about the
canonical location of the official GitLab-hosted mirror more easily.

In any case, regardless of which location it is going to be, I certainly
agree that having CI jobs running for it would be great. Folks here at
GitLab are mostly on vacation though, but I'll take care of this once
they are back and once Ævar has responded so that I can get access to
the current official mirror.

Patrick